// ------------------------------------------------------------
// PR
// 
// Copyright (c) 2003 IMAGIRE Takashi. All rights reserved.
// ------------------------------------------------------------

// ------------------------------------------------------------
// O[oϐ
// ------------------------------------------------------------
float4x4 mWVP;

// ------------------------------------------------------------
// eNX`
// ------------------------------------------------------------
texture SrcTex;
sampler SrcSamp = sampler_state
{
    Texture = <SrcTex>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};
// ------------------------------------------------------------
texture RadianceTex;
sampler RadianceSamp = sampler_state
{
    Texture = <RadianceTex>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};
// ------------------------------------------------------------
// _VF[_sNZVF[_ɓnf[^
// ------------------------------------------------------------
struct VS_OUTPUT
{
    float4 Pos			: POSITION;
    float4 Color		: COLOR0;
	float2 Tex0			: TEXCOORD0;
};

// ------------------------------------------------------------
// ƖvZȂ_VF[_vO
// ------------------------------------------------------------
VS_OUTPUT VS (
      float4 Pos    : POSITION           // f̒_
     ,float4 Normal : NORMAL             // @xNg
     ,float4 Tex0   : TEXCOORD0	         // eNX`W
){
    VS_OUTPUT Out = (VS_OUTPUT)0;        // o̓f[^
    
	// ʒuW
	Out.Pos = mul( Pos, mWVP );
	
    Out.Tex0 = Tex0;
	
    return Out;
}
// ------------------------------------------------------------
// S݃sNZVF[_vO
// ------------------------------------------------------------
float4 PS (VS_OUTPUT In) : COLOR
{
	float4 Out;
	
	// F
	Out = tex2D( SrcSamp, In.Tex0 ) * tex2D( RadianceSamp, In.Tex0 );
	
	return Out;
}
// ------------------------------------------------------------
// eNX`Ȃ
// ------------------------------------------------------------
float4 PS_NoTex (VS_OUTPUT In) : COLOR
{
	float4 Out;
	
	// F
	Out = tex2D( RadianceSamp, In.Tex0 );
	
	return Out;
}
// ------------------------------------------------------------
// ƖvZȂsNZVF[_vO
// ------------------------------------------------------------
float4 PS_NoGI (VS_OUTPUT In) : COLOR
{
	float4 Out;
	
	// F
	Out = tex2D( SrcSamp, In.Tex0 );
	
	return Out;
}


// ------------------------------------------------------------
// ------------------------------------------------------------
// ʒuA@}bv̍쐬
// ------------------------------------------------------------
// ------------------------------------------------------------
struct VS_OUTPUT_MAP
{
    float4 Pos			: POSITION;
	float4 Position		: TEXCOORD0;
	float4 Normal		: TEXCOORD1;
};
struct PS_OUTPUT_MAP
{
    float4 Position		: COLOR0;
    float4 Normal		: COLOR1;
};

// ------------------------------------------------------------
// _VF[_
// ------------------------------------------------------------
VS_OUTPUT_MAP VS_Map (
      float4 Pos    : POSITION           // f̒_
    , float4 Normal : NORMAL             // @xNg
    , float4 Tex0   : TEXCOORD0	         // eNX`W
){
    float MAP_SIZE = 256;
    VS_OUTPUT_MAP Out = (VS_OUTPUT_MAP)0;        // o̓f[^
    
    float4 pos = mul( Pos, mWVP );
    
	// ʒuW
	Out.Pos.x =  2.0 * (Tex0.x*(MAP_SIZE+1)/MAP_SIZE - 1/MAP_SIZE) - 1.0;
	Out.Pos.y = -2.0 * (Tex0.y*(MAP_SIZE+1)/MAP_SIZE - 1/MAP_SIZE) + 1.0;
	Out.Pos.z = 0.5;
	Out.Pos.w = 1;
	
	// F
	Out.Position = Pos;
	Out.Normal   = Normal;

    return Out;
}


// ------------------------------------------------------------
// sNZVF[_
// ------------------------------------------------------------
PS_OUTPUT_MAP PS_Map (VS_OUTPUT_MAP In)
{
	PS_OUTPUT_MAP Out;
	
	Out.Position = In.Position;
	Out.Normal   = In.Normal;

	return Out;
}

// ------------------------------------------------------------
// ------------------------------------------------------------
// fBAX̌vZ
// ------------------------------------------------------------
// ------------------------------------------------------------
struct VS_OUTPUT_RADIANCE
{
    float4 Pos			: POSITION;
    float4 Color		: COLOR0;
    float4 Depth		: TEXCOORD0;
};

// ------------------------------------------------------------
// _VF[_vO
// ------------------------------------------------------------
VS_OUTPUT_RADIANCE VS_Radiance (
      float4 Pos    : POSITION           // f̒_
     ,float4 Normal : NORMAL             // @xNg
     ,float4 Tex0   : TEXCOORD0	         // eNX`W
){
    VS_OUTPUT_RADIANCE Out = (VS_OUTPUT_RADIANCE)0;        // o̓f[^
    
    float4 pos = mul( Pos, mWVP );
    
	// ʒuW
	float rlen = rsqrt(dot(pos.xyz, pos.xyz));
	pos *= rlen;
	Out.Pos = pos;
	Out.Pos.w = 1;
	
    Out.Color = 0;
    
    Out.Depth = pos.z;
	
    return Out;
}
// ------------------------------------------------------------
// sNZVF[_vO
// ------------------------------------------------------------
float4 PS_Radiance (VS_OUTPUT_RADIANCE In) : COLOR
{
	// i[xājʂ
	clip(In.Depth);
	
	return In.Color;
}




// ------------------------------------------------------------
// ------------------------------------------------------------
// Օ}bv̍쐬
// ------------------------------------------------------------
// ------------------------------------------------------------

// ------------------------------------------------------------
// O[oϐ
// ------------------------------------------------------------
float MAP_WIDTH;
float MAP_HEIGHT;

// ------------------------------------------------------------
// eNX`
// ------------------------------------------------------------
texture ReductionMap;
sampler ReductionSamp = sampler_state
{
    Texture = <ReductionMap>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};
// ------------------------------------------------------------
// _VF[_sNZVF[_ɓnf[^
// ------------------------------------------------------------
struct VS_OUTPUT_REDUCTION
{
    float4 Pos			: POSITION;
	float2 Tex0			: TEXCOORD0;
	float2 Tex1			: TEXCOORD1;
	float2 Tex2			: TEXCOORD2;
	float2 Tex3			: TEXCOORD3;
	float2 Tex4			: TEXCOORD4;
	float2 Tex5			: TEXCOORD5;
	float2 Tex6			: TEXCOORD6;
	float2 Tex7			: TEXCOORD7;
};

// ------------------------------------------------------------
// _VF[_vO
// ------------------------------------------------------------
VS_OUTPUT_REDUCTION VS_Reduction (
      float4 Pos    : POSITION           // f̒_
     ,float4 Tex    : TEXCOORD0	         // eNX`W
){
    VS_OUTPUT_REDUCTION Out = (VS_OUTPUT_REDUCTION)0;        // o̓f[^
    
    // ʒuW
    Out.Pos = Pos;
    
    Out.Tex0 = Tex + float2(3.0f/MAP_WIDTH, 1.0f/MAP_HEIGHT);
    Out.Tex1 = Tex + float2(3.0f/MAP_WIDTH, 3.0f/MAP_HEIGHT);
    Out.Tex2 = Tex + float2(3.0f/MAP_WIDTH, 5.0f/MAP_HEIGHT);
    Out.Tex3 = Tex + float2(3.0f/MAP_WIDTH, 7.0f/MAP_HEIGHT);
    Out.Tex4 = Tex + float2(1.0f/MAP_WIDTH, 1.0f/MAP_HEIGHT);
    Out.Tex5 = Tex + float2(1.0f/MAP_WIDTH, 3.0f/MAP_HEIGHT);
    Out.Tex6 = Tex + float2(1.0f/MAP_WIDTH, 5.0f/MAP_HEIGHT);
    Out.Tex7 = Tex + float2(1.0f/MAP_WIDTH, 7.0f/MAP_HEIGHT);
    
    return Out;
}

// ------------------------------------------------------------
// sNZVF[_vO
// ------------------------------------------------------------
float4 PS_Reduction ( VS_OUTPUT_REDUCTION In ) : COLOR0
{
	float4 t0 = tex2D(ReductionSamp, In.Tex0);
	float4 t1 = tex2D(ReductionSamp, In.Tex1);
	float4 t2 = tex2D(ReductionSamp, In.Tex2);
	float4 t3 = tex2D(ReductionSamp, In.Tex3);
	
	float4 t4 = tex2D(ReductionSamp, In.Tex4);
	float4 t5 = tex2D(ReductionSamp, In.Tex5);
	float4 t6 = tex2D(ReductionSamp, In.Tex6);
	float4 t7 = tex2D(ReductionSamp, In.Tex7);
	
	float4 t8 = tex2D(ReductionSamp, In.Tex0 + float2(+4.0f/MAP_WIDTH, 0));
	float4 t9 = tex2D(ReductionSamp, In.Tex1 + float2(+4.0f/MAP_WIDTH, 0));
	float4 ta = tex2D(ReductionSamp, In.Tex2 + float2(+4.0f/MAP_WIDTH, 0));
	float4 tb = tex2D(ReductionSamp, In.Tex3 + float2(+4.0f/MAP_WIDTH, 0));
	
	float4 tc = tex2D(ReductionSamp, In.Tex4 + float2(+4.0f/MAP_WIDTH, 0));
	float4 td = tex2D(ReductionSamp, In.Tex5 + float2(+4.0f/MAP_WIDTH, 0));
	float4 te = tex2D(ReductionSamp, In.Tex6 + float2(+4.0f/MAP_WIDTH, 0));
	float4 tf = tex2D(ReductionSamp, In.Tex7 + float2(+4.0f/MAP_WIDTH, 0));
	
	return ((t0+t1+t2+t3)
		   +(t4+t5+t6+t7)
		   +(t8+t9+ta+tb)
		   +(tc+td+te+tf))/16;
}




// ------------------------------------------------------------
// At@ŐF
// ------------------------------------------------------------
float4 PS_Div ( float4 Tex0 : TEXCOORD0 ) : COLOR0
{
	float4 samp = tex2D(SrcSamp, Tex0);
	
	if(samp.w != 0) samp /= samp.w;
	
	return samp;
}




// ------------------------------------------------------------
// eNjbN
// ------------------------------------------------------------
technique TShader
{
    pass P0 // ʒuA@}bv
    {
        VertexShader = compile vs_1_1 VS_Map();
        PixelShader  = compile ps_2_0 PS_Map();
    }
    pass P1 // fBAX̌vZ
    {
        VertexShader = compile vs_1_1 VS_Radiance();
        PixelShader  = compile ps_2_0 PS_Radiance();
    }
    pass P2 // k
    {
        VertexShader = compile vs_1_1 VS_Reduction();
        PixelShader  = compile ps_2_0 PS_Reduction();
    }
    pass P3 // At@ŐF
    {
        PixelShader  = compile ps_2_0 PS_Div();
    }
    pass P4 // eNX`Ȃ
    {
        VertexShader = compile vs_1_1 VS();
        PixelShader  = compile ps_2_0 PS_NoTex();
    }
    pass P5// GIȂ
    {
        VertexShader = compile vs_1_1 VS();
        PixelShader  = compile ps_2_0 PS_NoGI();
    }
    pass P6
    {
        VertexShader = compile vs_1_1 VS();
        PixelShader  = compile ps_2_0 PS();
    }
}
