//-------------------------------------------------------------
// File: main.cpp
//
// Desc: PR
//-------------------------------------------------------------
#define STRICT
#include <windows.h>
#include <commctrl.h>
#include <commdlg.h>
#include <basetsd.h>
#include <math.h>
#include <stdio.h>
#include <d3dx9.h>
#include <dxerr9.h>
#include <tchar.h>
#include "DXUtil.h"
#include "D3DEnumeration.h"
#include "D3DSettings.h"
#include "D3DApp.h"
#include "D3DFont.h"
#include "D3DFile.h"
#include "D3DUtil.h"
#include "resource.h"
#include "main.h"

#define MAP_SIZE		256
#define DIFFUSE_SIZE	64


// Zk`Ă݂
#define RS   m_pd3dDevice->SetRenderState
#define TSS  m_pd3dDevice->SetTextureStageState
#define SAMP m_pd3dDevice->SetSamplerState


//-------------------------------------------------------------
// _̍\
//-------------------------------------------------------------
typedef struct {
    FLOAT       p[4];
    FLOAT       tu, tv;
} TVERTEX;

typedef struct {
    FLOAT       p[4];
    FLOAT       t[4][2];
} T4VERTEX;

//-------------------------------------------------------------
// O[oϐ
//-------------------------------------------------------------
CMyD3DApplication* g_pApp  = NULL;
HINSTANCE          g_hInst = NULL;

//-------------------------------------------------------------
// Name: WinMain()
// Desc: C֐
//-------------------------------------------------------------
INT WINAPI WinMain( HINSTANCE hInst, HINSTANCE, LPSTR, INT )
{
    CMyD3DApplication d3dApp;

    g_pApp  = &d3dApp;
    g_hInst = hInst;

    InitCommonControls();
    if( FAILED( d3dApp.Create( hInst ) ) )
        return 0;

    return d3dApp.Run();
}




//-------------------------------------------------------------
// Name: CMyD3DApplication()
// Desc: AvP[ṼRXgN^
//-------------------------------------------------------------
CMyD3DApplication::CMyD3DApplication()
{
	m_iState = -1;
	m_Shader = 0;

	m_pMeshBg					= new CD3DMesh();

	m_pMapZ						= NULL;
	m_pPosTex					= NULL;
	m_pPosSurf					= NULL;
	m_pPosLockTex				= NULL;
	m_pPosLockSurf				= NULL;
	m_pNormalTex				= NULL;
	m_pNormalSurf				= NULL;
	m_pNormalLockTex			= NULL;
	m_pNormalLockSurf			= NULL;
	m_pDiffuseTex				= NULL;
	m_pDiffuseSurf				= NULL;
	m_pFinalTex					= NULL;
	m_pFinalSurf				= NULL;
	for(int i=0;i<REDUCTION_MAPS;i++){
		m_pReductionTex[i]			= NULL;
		m_pReductionSurf[i]			= NULL;
	}

	m_pEffect					= NULL;
	m_hTechnique  				= NULL;
	m_hmWVP						= NULL;
	m_htSrcTex					= NULL;

	m_fWorldRotX                = -0.5f;
    m_fWorldRotY                = 0.0f;
	m_fViewZoom				    = 13.0f;

	m_LighPos					= D3DXVECTOR3( -5.0f, 5.0f,-2.0f );

	m_dwCreationWidth           = 512;
    m_dwCreationHeight          = 512;
    m_strWindowTitle            = TEXT( "main" );
    m_d3dEnumeration.AppUsesDepthBuffer   = TRUE;
	m_bStartFullscreen			= false;
	m_bShowCursorWhenFullscreen	= false;

    m_pFont                     = new CD3DFont( _T("Arial"), 12, D3DFONT_BOLD );
    m_bLoadingApp               = TRUE;

    ZeroMemory( &m_UserInput, sizeof(m_UserInput) );
}




//-------------------------------------------------------------
// Name: ~CMyD3DApplication()
// Desc: fXgN^
//-------------------------------------------------------------
CMyD3DApplication::~CMyD3DApplication()
{
}




//-------------------------------------------------------------
// Name: OneTimeSceneInit()
// Desc: xs
//		EBhȄIDirect3D9̏͏IĂ܂B
//		ALPDIRECT3DDEVICE9 ̏͏IĂ܂B
//-------------------------------------------------------------
HRESULT CMyD3DApplication::OneTimeSceneInit()
{
    // [fBObZ[W\
    SendMessage( m_hWnd, WM_PAINT, 0, 0 );

    m_bLoadingApp = FALSE;

    return S_OK;
}




//-------------------------------------------------------------
// Name: ConfirmDevice()
// Desc: ̎ɌĂ΂܂BKvȔ\͂`FbN܂B
//-------------------------------------------------------------
HRESULT CMyD3DApplication::ConfirmDevice( D3DCAPS9* pCaps,
                     DWORD dwBehavior,    D3DFORMAT Format )
{
    UNREFERENCED_PARAMETER( Format );
    UNREFERENCED_PARAMETER( dwBehavior );
    UNREFERENCED_PARAMETER( pCaps );
    

	// sNZVF[_o[W`FbN
    if( pCaps->PixelShaderVersion < D3DPS_VERSION(2,0) )
		return E_FAIL;

    // _VF[_o[Wʂ\tgEFA_
    if( pCaps->VertexShaderVersion < D3DVS_VERSION(1,1)
    &&  0==(dwBehavior & D3DCREATE_SOFTWARE_VERTEXPROCESSING) )
			return E_FAIL;

    return S_OK;
}


//-------------------------------------------------------------
// Name: InitDeviceObjects()
// Desc: foCXꂽ̏܂B
//		t[obt@tH[}bgfoCX̎ނς
//		ɒʉ߂܂B
//		ŊmۂDeleteDeviceObjects()ŊJ܂
//-------------------------------------------------------------
HRESULT CMyD3DApplication::InitDeviceObjects()
{
    HRESULT hr;

	// nʂ̓ǂݍ
	if(FAILED(hr=m_pMeshBg->Create( m_pd3dDevice, _T("map.x"))))
        return DXTRACE_ERR( "Load Model", hr );
	m_pMeshBg->UseMeshMaterials(FALSE);// _OɃeNX`̐ݒȂ
        
	// VF[_̓ǂݍ
	LPD3DXBUFFER pErr;
    if( FAILED( hr = D3DXCreateEffectFromFile(
				m_pd3dDevice, "hlsl.fx", NULL, NULL, 
				D3DXSHADER_DEBUG , NULL, &m_pEffect, &pErr ))){
		MessageBox( NULL, (LPCTSTR)pErr->GetBufferPointer()
					, "ERROR", MB_OK);
		return DXTRACE_ERR( "CreateEffectFromFile", hr );
	}
	m_hTechnique = m_pEffect->GetTechniqueByName( "TShader" );
	m_hmWVP		 = m_pEffect->GetParameterByName( NULL, "mWVP" );
	m_htSrcTex   = m_pEffect->GetParameterByName( NULL, "SrcTex" );

	// tHg
    m_pFont->InitDeviceObjects( m_pd3dDevice );

    return S_OK;
}

//-------------------------------------------------------------
// ^񒆂G
//-------------------------------------------------------------
VOID WINAPI FillTex (D3DXVECTOR4* pOut, CONST D3DXVECTOR2* pTexCoord, 
CONST D3DXVECTOR2* pTexelSize, LPVOID pData)
{
	FLOAT x = 2.0f*(pTexCoord->x-0.5f);
    FLOAT y = 2.0f*(pTexCoord->y-0.5f);
    FLOAT col = (x*x+y*y<(1.0f-2.0f/DIFFUSE_SIZE)*(1.0f-2.0f/DIFFUSE_SIZE))
				? 1.0f : 0.0f;
	
	pOut->x = pOut->y = pOut->z = pOut->w = col;
}

//-------------------------------------------------------------
// Name: RestoreDeviceObjects()
// Desc: ʂ̃TCYύXꂽɌĂ΂܂B
//		mۂInvalidateDeviceObjects()ŊJ܂B
//-------------------------------------------------------------
HRESULT CMyD3DApplication::RestoreDeviceObjects()
{
	m_iState = -1;
	m_iChangeState = TRUE;

	DWORD i;

	// bV
	m_pMeshBg->RestoreDeviceObjects( m_pd3dDevice );

    // ̐ݒ
    D3DMATERIAL9 mtrl;
    D3DUtil_InitMaterial( mtrl, 1.0f, 0.0f, 0.0f );
    m_pd3dDevice->SetMaterial( &mtrl );


    // _OԂ̐ݒ
    RS( D3DRS_DITHERENABLE,   FALSE );
    RS( D3DRS_SPECULARENABLE, FALSE );
    RS( D3DRS_ZENABLE,        TRUE );
    RS( D3DRS_AMBIENT,        0x000F0F0F );
    
    TSS( 0, D3DTSS_COLOROP,   D3DTOP_MODULATE );
    TSS( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
    TSS( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );
    TSS( 0, D3DTSS_ALPHAOP,   D3DTOP_SELECTARG1 );
    TSS( 0, D3DTSS_ALPHAARG1, D3DTA_DIFFUSE );
    SAMP( 0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR );
    SAMP( 0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR );
    SAMP( 0, D3DSAMP_ADDRESSU, D3DTADDRESS_CLAMP );
    SAMP( 0, D3DSAMP_ADDRESSV, D3DTADDRESS_CLAMP );

    // [hs
    D3DXMATRIX matIdentity;
    D3DXMatrixIdentity( &m_mWorld );

	// r[s
    D3DXVECTOR3 vFromPt   = D3DXVECTOR3( 0.0f, 0.0f, -5.0f );
    D3DXVECTOR3 vLookatPt = D3DXVECTOR3( 0.0f, 0.0f, 0.0f );
    D3DXVECTOR3 vUpVec    = D3DXVECTOR3( 0.0f, 1.0f, 0.0f );
    D3DXMatrixLookAtLH( &m_mView, &vFromPt, &vLookatPt, &vUpVec );

    // ˉes
    FLOAT fAspect = ((FLOAT)m_d3dsdBackBuffer.Width) / m_d3dsdBackBuffer.Height;
    D3DXMatrixPerspectiveFovLH( &m_mProj, D3DX_PI/4, fAspect, 1.0f, 100.0f );

    // tHg
    m_pFont->RestoreDeviceObjects();

	// _O^[Qbg̐
	if (FAILED(m_pd3dDevice->CreateDepthStencilSurface(MAP_SIZE, MAP_SIZE, 
		D3DFMT_D16, D3DMULTISAMPLE_NONE, 0, TRUE, &m_pMapZ, NULL)))
		return E_FAIL;
	// ʒu}bv
	if (FAILED(m_pd3dDevice->CreateTexture(MAP_SIZE, MAP_SIZE, 1, 
		D3DUSAGE_RENDERTARGET, D3DFMT_A32B32G32R32F, D3DPOOL_DEFAULT, &m_pPosTex, NULL)))
		return E_FAIL;
	if (FAILED(m_pPosTex->GetSurfaceLevel(0, &m_pPosSurf)))
		return E_FAIL;
	if (FAILED(m_pd3dDevice->CreateTexture(MAP_SIZE, MAP_SIZE, 1, 
		0, D3DFMT_A32B32G32R32F, D3DPOOL_SYSTEMMEM , &m_pPosLockTex, NULL)))
		return E_FAIL;
	if (FAILED(m_pPosLockTex->GetSurfaceLevel(0, &m_pPosLockSurf)))
		return E_FAIL;
	// @}bv
	if (FAILED(m_pd3dDevice->CreateTexture(MAP_SIZE, MAP_SIZE, 1, 
		D3DUSAGE_RENDERTARGET, D3DFMT_A32B32G32R32F, D3DPOOL_DEFAULT, &m_pNormalTex, NULL)))
		return E_FAIL;
	if (FAILED(m_pNormalTex->GetSurfaceLevel(0, &m_pNormalSurf)))
		return E_FAIL;
	if (FAILED(m_pd3dDevice->CreateTexture(MAP_SIZE, MAP_SIZE, 1, 
		0, D3DFMT_A32B32G32R32F, D3DPOOL_SYSTEMMEM , &m_pNormalLockTex, NULL)))
		return E_FAIL;
	if (FAILED(m_pNormalLockTex->GetSurfaceLevel(0, &m_pNormalLockSurf)))
		return E_FAIL;
	// gU}bv
	if (FAILED(m_pd3dDevice->CreateTexture(MAP_SIZE, MAP_SIZE, 1, 
		D3DUSAGE_RENDERTARGET, D3DFMT_A8R8G8B8, D3DPOOL_DEFAULT, &m_pDiffuseTex, NULL)))
		return E_FAIL;
	if (FAILED(m_pDiffuseTex->GetSurfaceLevel(0, &m_pDiffuseSurf)))
		return E_FAIL;
	if (FAILED(m_pd3dDevice->CreateTexture(MAP_SIZE, MAP_SIZE, 1, 
		D3DUSAGE_RENDERTARGET, D3DFMT_A8R8G8B8, D3DPOOL_DEFAULT, &m_pFinalTex, NULL)))
		return E_FAIL;
	if (FAILED(m_pFinalTex->GetSurfaceLevel(0, &m_pFinalSurf)))
		return E_FAIL;

	// kobt@
	for(i=0;i<REDUCTION_MAPS;i++){
		int size = 1<<(3*(REDUCTION_MAPS-i));
		if (FAILED(m_pd3dDevice->CreateTexture(size, size, 1, 
			D3DUSAGE_RENDERTARGET, D3DFMT_A8R8G8B8, D3DPOOL_DEFAULT, &m_pReductionTex[i], NULL)))
			return E_FAIL;
		if (FAILED(m_pReductionTex[i]->GetSurfaceLevel(0, &m_pReductionSurf[i])))
			return E_FAIL;
	}

	// }XNp̃eNX`̐
    if( FAILED(m_pd3dDevice->CreateTexture(DIFFUSE_SIZE, DIFFUSE_SIZE, 1
                          , D3DUSAGE_RENDERTARGET, D3DFMT_A8R8G8B8
                          , D3DPOOL_DEFAULT, &m_pMaskTex, NULL)))
        return E_FAIL;
    if( FAILED(D3DXFillTexture(m_pMaskTex, FillTex, NULL)))
        return E_FAIL;

	m_pEffect->OnResetDevice();

	return S_OK;
}


//-------------------------------------------------------------
// Name: FrameMoveCreateMap()
// Desc: ʒuA@}bv쐬B
//-------------------------------------------------------------
int CMyD3DApplication::FrameMoveCreateMap()
{
	// Qڂ̈ȍ~͎̏Ɉڂ
	if(1<m_iCount) return 1;

	return 0;
}
//-------------------------------------------------------------
// Name: RenderCreateMap()
// Desc: ʒuA@}bv쐬B
//-------------------------------------------------------------
void CMyD3DApplication::RenderCreateMap()
{
	LPDIRECT3DSURFACE9 pOldBackBuffer, pOldZBuffer;
	D3DVIEWPORT9 oldViewport;

    if( SUCCEEDED( m_pd3dDevice->BeginScene() ) )
    {
		//-------------------------------------------------
		// _O^[Qbg̕ۑ
		//-------------------------------------------------
		m_pd3dDevice->GetRenderTarget(0, &pOldBackBuffer);
		m_pd3dDevice->GetDepthStencilSurface(&pOldZBuffer);
		m_pd3dDevice->GetViewport(&oldViewport);

		//-------------------------------------------------
		// _O^[Qbg̕ύX
		//-------------------------------------------------
		m_pd3dDevice->SetRenderTarget(0, m_pPosSurf);
		m_pd3dDevice->SetRenderTarget(1, m_pNormalSurf);
		m_pd3dDevice->SetDepthStencilSurface(NULL);
		// r[|[g̕ύX
		D3DVIEWPORT9 viewport_height = {0,0      // ̍W
						, MAP_SIZE  // 
						, MAP_SIZE // 
						, 0.0f,1.0f};     // OʁA
		m_pd3dDevice->SetViewport(&viewport_height);

		//-------------------------------------------------
		// t[obt@̃NA
		//-------------------------------------------------
		m_pd3dDevice->Clear(0L, NULL
						, D3DCLEAR_TARGET
						, 0x00000000, 1.0f, 0L);

		if( m_pEffect != NULL ) 
		{
			//-------------------------------------------------
			// VF[_̐ݒ
			//-------------------------------------------------
			m_pEffect->SetTechnique( m_hTechnique );
			m_pEffect->Begin( NULL, 0 );
			m_pEffect->Pass( 0 );

			RS( D3DRS_ZENABLE, FALSE );
			RS( D3DRS_CULLMODE, D3DCULL_NONE );

			//-------------------------------------------------
			// wi̕`
			//-------------------------------------------------
			m_pMeshBg->Render(m_pd3dDevice);

			RS( D3DRS_ZENABLE, TRUE );
			RS( D3DRS_CULLMODE, D3DCULL_CCW );

			m_pEffect->End();
		}

		//-----------------------------------------------------
		// _O^[Qbgɖ߂
		//-----------------------------------------------------
		m_pd3dDevice->SetRenderTarget(0, pOldBackBuffer);
		m_pd3dDevice->SetRenderTarget(1, NULL);
		m_pd3dDevice->SetDepthStencilSurface(pOldZBuffer);
		m_pd3dDevice->SetViewport(&oldViewport);
		pOldBackBuffer->Release();
		pOldZBuffer->Release();

		//-----------------------------------------------------
		// ܂̉
		//-----------------------------------------------------
		m_pd3dDevice->Clear(0L, NULL
						, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER
						, 0xff000000, 1.0f, 0L);

		m_pd3dDevice->EndScene();
	}
}


//-------------------------------------------------------------
// Name: FrameMoveCreateMap()
// Desc: ʒuA@}bv쐬B
//-------------------------------------------------------------
static int ix=0;
static int iy=0;
static float pos[MAP_SIZE][MAP_SIZE][3];
static float normal[MAP_SIZE][MAP_SIZE][3];
int CMyD3DApplication::FrameMoveFinalGathering()
{
	ix = this->m_iCount % MAP_SIZE;
	iy = this->m_iCount / MAP_SIZE;
	
	if(0==this->m_iCount){
		D3DLOCKED_RECT d3dlr;
		float *p;
		m_pd3dDevice->GetRenderTargetData(m_pPosSurf,m_pPosLockSurf);
		m_pPosLockSurf->LockRect(&d3dlr,NULL,D3DLOCK_READONLY); //T[tFCX̋`bN    
		p = (float *)d3dlr.pBits;
		for(int y=0;y<MAP_SIZE;y++){
		for(int x=0;x<MAP_SIZE;x++){
			pos[x][y][0]=p[0];
			pos[x][y][1]=p[1];
			pos[x][y][2]=p[2];
			p+=4;
		}
		}
		m_pPosLockSurf->UnlockRect();

		m_pd3dDevice->GetRenderTargetData(m_pNormalSurf,m_pNormalLockSurf);
		m_pNormalLockSurf->LockRect(&d3dlr,NULL,D3DLOCK_READONLY); //T[tFCX̋`bN    
		p = (float *)d3dlr.pBits;        
		for(int y=0;y<MAP_SIZE;y++){
		for(int x=0;x<MAP_SIZE;x++){
			normal[x][y][0]=p[0];
			normal[x][y][1]=p[1];
			normal[x][y][2]=p[2];
			p+=4;
		}
		}
		m_pNormalLockSurf->UnlockRect();
	}

	// I
	if(MAP_SIZE-1==ix && MAP_SIZE-1==iy) return 1;

	return 0;
}
//-------------------------------------------------------------
// Name: RenderFinalGathering()
// Desc: ꂼ̈ʒũfBAXvZB
//-------------------------------------------------------------
void CMyD3DApplication::RenderFinalGathering()
{
    D3DXMATRIX m, mView;
	LPDIRECT3DSURFACE9 pOldBackBuffer, pOldZBuffer;
	D3DVIEWPORT9 oldViewport;
	D3DSURFACE_DESC d3dsd;

	D3DVIEWPORT9 viewport = {0,0      // ̍W
					, 1, 1  // ,
					, 0.0f,1.0f};     // OʁA

	if( SUCCEEDED( m_pd3dDevice->BeginScene() ) )
    {
		RS( D3DRS_ZENABLE, FALSE );
		RS( D3DRS_CULLMODE, D3DCULL_NONE );

		//-------------------------------------------------
		// _O^[Qbg̕ۑ
		//-------------------------------------------------
		m_pd3dDevice->GetRenderTarget(0, &pOldBackBuffer);
		m_pd3dDevice->GetDepthStencilSurface(&pOldZBuffer);
		m_pd3dDevice->GetViewport(&oldViewport);

		//-------------------------------------------------
		//-------------------------------------------------
		// e_猩fBAX̕`
		//-------------------------------------------------
		//-------------------------------------------------

		//-------------------------------------------------
		// _O^[Qbg̕ύX
		//-------------------------------------------------
		m_pd3dDevice->SetRenderTarget(0, m_pReductionSurf[0]);
		m_pd3dDevice->SetDepthStencilSurface(NULL);
		// r[|[g̕ύX
		m_pReductionSurf[0]->GetDesc(&d3dsd);
		viewport.Height = d3dsd.Width;
		viewport.Width  = d3dsd.Height;
		m_pd3dDevice->SetViewport(&viewport);

		//-------------------------------------------------
		// d݂̕`
		//-------------------------------------------------
		{
		m_pd3dDevice->SetTextureStageState(0,D3DTSS_COLOROP,	D3DTOP_SELECTARG1);
		m_pd3dDevice->SetTextureStageState(0,D3DTSS_COLORARG1,	D3DTA_TEXTURE);
		m_pd3dDevice->SetTextureStageState(1,D3DTSS_COLOROP,    D3DTOP_DISABLE);
		m_pd3dDevice->SetTextureStageState(0,D3DTSS_ALPHAOP,	D3DTOP_SELECTARG1);
		m_pd3dDevice->SetTextureStageState(0,D3DTSS_ALPHAARG1,	D3DTA_TEXTURE);
		m_pd3dDevice->SetTextureStageState(1,D3DTSS_ALPHAOP,    D3DTOP_DISABLE);
		m_pd3dDevice->SetVertexShader(NULL);
		m_pd3dDevice->SetPixelShader(0);
		m_pd3dDevice->SetFVF( D3DFVF_XYZRHW | D3DFVF_TEX1 );
		TVERTEX Vertex[4] = {
			// x  y  z rhw tu tv
			{          0,           0,0, 1, 0, 0,},
			{d3dsd.Width,           0,0, 1, 1, 0,},
			{d3dsd.Width,d3dsd.Height,0, 1, 1, 1,},
			{          0,d3dsd.Height,0, 1, 0, 1,},
		};
		m_pd3dDevice->SetTexture( 0, m_pMaskTex );
		m_pd3dDevice->DrawPrimitiveUP( D3DPT_TRIANGLEFAN, 2, Vertex, sizeof( TVERTEX ) );
		}

		if( m_pEffect != NULL ) 
		{
			//-------------------------------------------------
			// VF[_̐ݒ
			//-------------------------------------------------
			m_pEffect->SetTechnique( m_hTechnique );
			m_pEffect->Begin( NULL, 0 );
			m_pEffect->Pass( 1 );
			
			// At@͏܂Ȃ
			RS(D3DRS_COLORWRITEENABLE, D3DCOLORWRITEENABLE_RED |D3DCOLORWRITEENABLE_GREEN |D3DCOLORWRITEENABLE_BLUE );

			//-------------------------------------------------
			// wi̕`
			//-------------------------------------------------
			float x[3] = {pos[ix][iy][0], pos[ix][iy][1], pos[ix][iy][2]};
			float n[3] = {normal[ix][iy][0], normal[ix][iy][1], normal[ix][iy][2]};
			D3DXVECTOR3 vFromPt   = D3DXVECTOR3( x[0], x[1], x[2] ) + 0.05f*D3DXVECTOR3( n[0], n[1], n[2] );
			D3DXVECTOR3 vLookatPt = D3DXVECTOR3( n[0], n[1], n[2] ) + vFromPt;
			D3DXVECTOR3 vUpVec    = D3DXVECTOR3( 0.0f, 1.0f, 0.0f );
			D3DXMatrixLookAtLH( &mView, &vFromPt, &vLookatPt, &vUpVec );

			m_pEffect->SetMatrix( m_hmWVP, &mView );

			m_pMeshBg->Render(m_pd3dDevice);


			RS(D3DRS_COLORWRITEENABLE, 0xf );
			m_pEffect->End();
		}
		//-------------------------------------------------
		//-------------------------------------------------
		// fBAX~bv}bv̗v̂ŏ
		//-------------------------------------------------
		//-------------------------------------------------
		m_pd3dDevice->SetRenderTarget(0, m_pReductionSurf[1]);
		m_pd3dDevice->SetDepthStencilSurface(NULL);
		// r[|[g̕ύX
		m_pReductionSurf[1]->GetDesc(&d3dsd);
		viewport.Height = d3dsd.Width;
		viewport.Width  = d3dsd.Height;
		m_pd3dDevice->SetViewport(&viewport);

		TSS(0,D3DTSS_COLOROP,	D3DTOP_SELECTARG1);
		TSS(0,D3DTSS_COLORARG1,	D3DTA_TEXTURE);
		TSS(1,D3DTSS_COLOROP,   D3DTOP_DISABLE);
		
		if( m_pEffect != NULL ) {
			//-------------------------------------------------
			// VF[_̐ݒ
			//-------------------------------------------------
			m_pEffect->SetTechnique( m_hTechnique );
			m_pEffect->Begin( NULL, 0 );
			m_pEffect->Pass( 2 );

			m_pEffect->SetFloat("MAP_WIDTH",  DIFFUSE_SIZE);
			m_pEffect->SetFloat("MAP_HEIGHT", DIFFUSE_SIZE);

			//-------------------------------------------------
			// tB^O
			//-------------------------------------------------
			TVERTEX Vertex1[4] = {
				//   x    y     z    tu tv
				{-1.0f, +1.0f, 0.1f,  0, 0},
				{+1.0f, +1.0f, 0.1f,  1, 0},
				{+1.0f, -1.0f, 0.1f,  1, 1},
				{-1.0f, -1.0f, 0.1f,  0, 1},
			};
			m_pd3dDevice->SetFVF( D3DFVF_XYZ | D3DFVF_TEX1 );
			m_pEffect->SetTexture("ReductionMap", m_pReductionTex[0]);
			m_pd3dDevice->DrawPrimitiveUP( D3DPT_TRIANGLEFAN
							, 2, Vertex1, sizeof( TVERTEX ) );

			m_pEffect->End();
		}

		//-------------------------------------------------
		//-------------------------------------------------
		// fBAXeNX`̑Ήʒuɒ
		//-------------------------------------------------
		//-------------------------------------------------
		m_pd3dDevice->SetRenderTarget(0, m_pDiffuseSurf);
		m_pd3dDevice->SetDepthStencilSurface(NULL);
		// r[|[g̕ύX
		m_pDiffuseSurf->GetDesc(&d3dsd);
		viewport.Height = d3dsd.Width;
		viewport.Width  = d3dsd.Height;
		m_pd3dDevice->SetViewport(&viewport);
		
		// mF₷邽߂ɁAŏ͐ԂhԂ
		if(0==ix&&0==iy)m_pd3dDevice->Clear(0L, NULL, D3DCLEAR_TARGET, 0x00800000, 1.0f, 0L);

		if( m_pEffect != NULL ) {
			//-------------------------------------------------
			// VF[_̐ݒ
			//-------------------------------------------------
			m_pEffect->SetTechnique( m_hTechnique );
			m_pEffect->Begin( NULL, 0 );
			m_pEffect->Pass( 2 );

			m_pEffect->SetFloat("MAP_WIDTH",  8);
			m_pEffect->SetFloat("MAP_HEIGHT", 8);

			//-------------------------------------------------
			// tB^O
			//-------------------------------------------------
			float x =  2.0f*((float)ix/(float)MAP_SIZE) - 1.0f;
			float y = -2.0f*((float)iy/(float)MAP_SIZE) + 1.0f;
			TVERTEX Vertex1[4] = {
				//   x    y     z    tu tv
				{x,                      y,                     0.1f,  0, 0},
				{x+2.0f/(float)MAP_SIZE, y,                     0.1f,  1, 0},
				{x+2.0f/(float)MAP_SIZE, y-2.0f/(float)MAP_SIZE,0.1f,  1, 1},
				{x,                      y-2.0f/(float)MAP_SIZE,0.1f,  0, 1},
			};
			m_pd3dDevice->SetFVF( D3DFVF_XYZ | D3DFVF_TEX1 );
			m_pEffect->SetTexture("ReductionMap", m_pReductionTex[1]);
			m_pd3dDevice->DrawPrimitiveUP( D3DPT_TRIANGLEFAN
							, 2, Vertex1, sizeof( TVERTEX ) );

			m_pEffect->End();
		}
		
		//-----------------------------------------------------
		// ŏIt[ł́AAt@̒lŌʂiKj
		//-----------------------------------------------------
		if(MAP_SIZE-1==ix && MAP_SIZE-1==iy){
			m_pd3dDevice->SetRenderTarget(0, m_pFinalSurf);
			m_pd3dDevice->SetDepthStencilSurface(NULL);
			// r[|[g̕ύX
			m_pFinalSurf->GetDesc(&d3dsd);
			viewport.Height = d3dsd.Width;
			viewport.Width  = d3dsd.Height;
			m_pd3dDevice->SetViewport(&viewport);

			if( m_pEffect != NULL ) {
				m_pEffect->SetTechnique( m_hTechnique );
				m_pEffect->Begin( NULL, 0 );
				m_pEffect->Pass( 3 );

				TVERTEX Vertex[4] = {
					// x  y  z rhw tu tv
					{       0,       0,0, 1, 0+0.5f/(FLOAT)MAP_SIZE, 0+0.5f/(FLOAT)MAP_SIZE,},
					{MAP_SIZE,       0,0, 1, 1+0.5f/(FLOAT)MAP_SIZE, 0+0.5f/(FLOAT)MAP_SIZE,},
					{MAP_SIZE,MAP_SIZE,0, 1, 1+0.5f/(FLOAT)MAP_SIZE, 1+0.5f/(FLOAT)MAP_SIZE,},
					{       0,MAP_SIZE,0, 1, 0+0.5f/(FLOAT)MAP_SIZE, 1+0.5f/(FLOAT)MAP_SIZE,},
				};
				m_pd3dDevice->SetFVF( D3DFVF_XYZRHW | D3DFVF_TEX1 );
				m_pEffect->SetTexture(m_htSrcTex, m_pDiffuseTex);
				m_pd3dDevice->DrawPrimitiveUP( D3DPT_TRIANGLEFAN
								, 2, Vertex, sizeof( TVERTEX ) );

				m_pEffect->End();
			}
		}

		//-----------------------------------------------------
		// _O^[Qbgɖ߂
		//-----------------------------------------------------
		m_pd3dDevice->SetRenderTarget(0, pOldBackBuffer);
		m_pd3dDevice->SetRenderTarget(1, NULL);
		m_pd3dDevice->SetDepthStencilSurface(pOldZBuffer);
		m_pd3dDevice->SetViewport(&oldViewport);
		pOldBackBuffer->Release();
		pOldZBuffer->Release();

		RS( D3DRS_ZENABLE, TRUE );
		RS( D3DRS_CULLMODE, D3DCULL_CCW );

		//---------------------------------------------------------
		// ʂ̕\
		//---------------------------------------------------------
		m_pd3dDevice->Clear(0L, NULL
						, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER
						, 0x00001020, 1.0f, 0L);

#if 1 // fobOpɃeNX`\
		{
		m_pd3dDevice->SetTextureStageState(0,D3DTSS_COLOROP,	D3DTOP_SELECTARG1);
		m_pd3dDevice->SetTextureStageState(0,D3DTSS_COLORARG1,	D3DTA_TEXTURE);
		m_pd3dDevice->SetTextureStageState(1,D3DTSS_COLOROP,    D3DTOP_DISABLE);
		m_pd3dDevice->SetVertexShader(NULL);
		m_pd3dDevice->SetFVF( D3DFVF_XYZRHW | D3DFVF_TEX1 );
		m_pd3dDevice->SetPixelShader(0);
		float scale = 256.0f*2/3;
		for(DWORD i=0; i<3; i++){
			TVERTEX Vertex[4] = {
				// x  y  z rhw tu tv
				{    0,(i+0)*scale,0, 1, 0, 0,},
				{scale,(i+0)*scale,0, 1, 1, 0,},
				{scale,(i+1)*scale,0, 1, 1, 1,},
				{    0,(i+1)*scale,0, 1, 0, 1,},
			};
			if(0==i) m_pd3dDevice->SetTexture( 0, m_pDiffuseTex );
			if(1==i) m_pd3dDevice->SetTexture( 0, m_pReductionTex[0] );
			if(2==i) m_pd3dDevice->SetTexture( 0, m_pReductionTex[1] );
			m_pd3dDevice->DrawPrimitiveUP( D3DPT_TRIANGLEFAN, 2, Vertex, sizeof( TVERTEX ) );
		}
		}
#endif		

		D3DCOLOR fontColor        = D3DCOLOR_ARGB(255,255,255,0);
		TCHAR szMsg[MAX_PATH] = TEXT("");

		sprintf( szMsg, TEXT("x:%4d\ny:%4d"), ix, iy);
		m_pFont->DrawText( 2, (FLOAT)m_d3dsdBackBuffer.Height-40, fontColor, szMsg );

		m_pd3dDevice->EndScene();
	}
}


//-------------------------------------------------------------
// Name: FrameMove()
// Desc: t[Ă΂܂BAj̏Ȃǂs܂B
//-------------------------------------------------------------
HRESULT CMyD3DApplication::FrameMove()
{
	m_iCount++;
	
	if(m_iChangeState) {m_iState++;m_iCount=0;m_iChangeState=0;}

	switch(m_iState){
	case 0:
		m_iChangeState = this->FrameMoveCreateMap();
		return S_OK;
	case 1:
		m_iChangeState = this->FrameMoveFinalGathering();
		return S_OK;
	default:
		break;
	}


	// ̓f[^̍XV
    UpdateInput( &m_UserInput );

	//---------------------------------------------------------
	// ͂ɉčWnXV
	//---------------------------------------------------------
	// ]
    D3DXMATRIX matRotY;
    D3DXMATRIX matRotX;

    if( m_UserInput.bRotateLeft && !m_UserInput.bRotateRight )
        m_fWorldRotY += m_fElapsedTime;
    else
    if( m_UserInput.bRotateRight && !m_UserInput.bRotateLeft )
        m_fWorldRotY -= m_fElapsedTime;

    if( m_UserInput.bRotateUp && !m_UserInput.bRotateDown )
        m_fWorldRotX += m_fElapsedTime;
    else
    if( m_UserInput.bRotateDown && !m_UserInput.bRotateUp )
        m_fWorldRotX -= m_fElapsedTime;

    D3DXMatrixRotationX( &matRotX, m_fWorldRotX );
    D3DXMatrixRotationY( &matRotY, m_fWorldRotY );

    D3DXMatrixMultiply( &m_mWorld, &matRotY, &matRotX );
	
	//---------------------------------------------------------
	// r[s̐ݒ
	//---------------------------------------------------------
	// Y[
    if( m_UserInput.bZoomIn && !m_UserInput.bZoomOut )
        m_fViewZoom += m_fElapsedTime;
    else if( m_UserInput.bZoomOut && !m_UserInput.bZoomIn )
        m_fViewZoom -= m_fElapsedTime;

    D3DXVECTOR3 vFromPt   = D3DXVECTOR3( 0.0f, 0.0f, -m_fViewZoom );
    D3DXVECTOR3 vLookatPt = D3DXVECTOR3( 0.0f, 0.3f, 0.0f );
    D3DXVECTOR3 vUpVec    = D3DXVECTOR3( 0.0f, 1.0f, 0.0f );
    D3DXMatrixLookAtLH( &m_mView, &vFromPt, &vLookatPt, &vUpVec );

	//---------------------------------------------------------
	// VF[_̕ύX
	//---------------------------------------------------------
    if( m_UserInput.bChangeShader ) m_Shader = (m_Shader + 1) % 3;

	return S_OK;
}
//-------------------------------------------------------------
// Name: UpdateInput()
// Desc: ̓f[^XV
//-------------------------------------------------------------
void CMyD3DApplication::UpdateInput( UserInput* pUserInput )
{
    pUserInput->bRotateUp    = ( m_bActive && (GetAsyncKeyState( VK_UP )    & 0x8000) == 0x8000 );
    pUserInput->bRotateDown  = ( m_bActive && (GetAsyncKeyState( VK_DOWN )  & 0x8000) == 0x8000 );
    pUserInput->bRotateLeft  = ( m_bActive && (GetAsyncKeyState( VK_LEFT )  & 0x8000) == 0x8000 );
    pUserInput->bRotateRight = ( m_bActive && (GetAsyncKeyState( VK_RIGHT ) & 0x8000) == 0x8000 );
    
	pUserInput->bZoomIn      = ( m_bActive && (GetAsyncKeyState( 'Z'     )  & 0x8000) == 0x8000 );
    pUserInput->bZoomOut     = ( m_bActive && (GetAsyncKeyState( 'X'      ) & 0x8000) == 0x8000 );
    
	pUserInput->bChangeShader= ( m_bActive && (GetAsyncKeyState( 'A'      ) & 0x8001) == 0x8001 );
}


//-------------------------------------------------------------
// Name: Render()
// Desc: ʂ`悷.
//-------------------------------------------------------------
HRESULT CMyD3DApplication::Render()
{
	switch(m_iState){
	case 0:
		this->RenderCreateMap();
		return S_OK;
	case 1:
		this->RenderFinalGathering();
		return S_OK;
	default:
		break;
	}

    D3DXMATRIX m, mT, mR, mW, mView, mProj;
	DWORD i;
	D3DXVECTOR4 v;
	D3DMATERIAL9 *pMtrl;

	//---------------------------------------------------------
	// `
	//---------------------------------------------------------
    if( SUCCEEDED( m_pd3dDevice->BeginScene() ) )
    {
		// t[obt@̃NA
		m_pd3dDevice->Clear(0L, NULL
						, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER
						, 0xff000000, 1.0f, 0L);

		if( m_pEffect != NULL ) 
		{
			//-------------------------------------------------
			// VF[_̐ݒ
			//-------------------------------------------------
			m_pEffect->SetTechnique( m_hTechnique );
			m_pEffect->Begin( NULL, 0 );
			m_pEffect->Pass( 4+m_Shader );

			//-------------------------------------------------
			// V[̕`
			//-------------------------------------------------
			// ϊs
			m = m_mWorld * m_mView * m_mProj;
			m_pEffect->SetMatrix( m_hmWVP, &m );
			
			// wi̕`
			m_pEffect->SetTexture("RadianceTex", this->m_pFinalTex );
			pMtrl = m_pMeshBg->m_pMaterials;
			for( i=0; i<m_pMeshBg->m_dwNumMaterials; i++ ) {
				m_pEffect->SetTexture(m_htSrcTex, m_pMeshBg->m_pTextures[i] );
				m_pMeshBg->m_pLocalMesh->DrawSubset( i );	// `
				pMtrl++;
			}

			m_pEffect->End();
		}

        // wv̕\
        RenderText();

#if 1 // fobOpɃeNX`\
		{
		m_pd3dDevice->SetTextureStageState(0,D3DTSS_COLOROP,	D3DTOP_SELECTARG1);
		m_pd3dDevice->SetTextureStageState(0,D3DTSS_COLORARG1,	D3DTA_TEXTURE);
		m_pd3dDevice->SetTextureStageState(1,D3DTSS_COLOROP,    D3DTOP_DISABLE);
		m_pd3dDevice->SetVertexShader(NULL);
		m_pd3dDevice->SetFVF( D3DFVF_XYZRHW | D3DFVF_TEX1 );
		m_pd3dDevice->SetPixelShader(0);
		float scale = 96.0f;
		for(DWORD i=0; i<3; i++){
			TVERTEX Vertex[4] = {
				// x  y  z rhw tu tv
				{(i+0)*scale,    0,0, 1, 0, 0,},
				{(i+1)*scale,    0,0, 1, 1, 0,},
				{(i+1)*scale,scale,0, 1, 1, 1,},
				{(i+0)*scale,scale,0, 1, 0, 1,},
			};
			if(0==i) m_pd3dDevice->SetTexture( 0, m_pPosTex );
			if(1==i) m_pd3dDevice->SetTexture( 0, m_pNormalTex );
			if(2==i) m_pd3dDevice->SetTexture( 0, m_pFinalTex );
			m_pd3dDevice->DrawPrimitiveUP( D3DPT_TRIANGLEFAN, 2, Vertex, sizeof( TVERTEX ) );
		}
		}
#endif		

		// `̏I
        m_pd3dDevice->EndScene();
    }

    return S_OK;
}




//-------------------------------------------------------------
// Name: RenderText()
// Desc: Ԃwvʂɕ\
//-------------------------------------------------------------
HRESULT CMyD3DApplication::RenderText()
{
    D3DCOLOR fontColor        = D3DCOLOR_ARGB(255,255,255,0);
    TCHAR szMsg[MAX_PATH] = TEXT("");

    FLOAT fNextLine = 40.0f; // \鍂

    // @p[^\
    fNextLine = (FLOAT) m_d3dsdBackBuffer.Height; 

    lstrcpy( szMsg, TEXT("Press 'F2' to configure display") );
    fNextLine -= 20.0f;
    m_pFont->DrawText( 2, fNextLine, fontColor, szMsg );

    lstrcpy( szMsg, TEXT("Press 'A' to change shader") );
    fNextLine -= 20.0f;
    m_pFont->DrawText( 2, fNextLine, fontColor, szMsg );

    lstrcpy( szMsg, m_strDeviceStats );
    fNextLine -= 20.0f;
    m_pFont->DrawText( 2, fNextLine, fontColor, szMsg );
    lstrcpy( szMsg, m_strFrameStats );
    fNextLine -= 20.0f;
    m_pFont->DrawText( 2, fNextLine, fontColor, szMsg );
	
	return S_OK;
}




//-------------------------------------------------------------
// Name: MsgProc()
// Desc: WndProc I[o[Ch
//-------------------------------------------------------------
LRESULT CMyD3DApplication::MsgProc( HWND hWnd, UINT msg,
                                 WPARAM wParam, LPARAM lParam )
{
    switch( msg )
    {
        case WM_PAINT:
        {
            if( m_bLoadingApp )
            {
                // [h
                HDC hDC = GetDC( hWnd );
                TCHAR strMsg[MAX_PATH];
                wsprintf(strMsg, TEXT("Loading... Please wait"));
                RECT rct;
                GetClientRect( hWnd, &rct );
                DrawText( hDC, strMsg, -1, &rct
                		, DT_CENTER|DT_VCENTER|DT_SINGLELINE );
                ReleaseDC( hWnd, hDC );
            }
            break;
        }

    }

    return CD3DApplication::MsgProc( hWnd, msg, wParam, lParam );
}




//-------------------------------------------------------------
// Name: InvalidateDeviceObjects()
// Desc: RestoreDeviceObjects() ō쐬IuWFNg̊J
//-------------------------------------------------------------
HRESULT CMyD3DApplication::InvalidateDeviceObjects()
{
	// _O^[Qbg
	SAFE_RELEASE(m_pMaskTex);
	for(int i=0;i<REDUCTION_MAPS;i++){
		SAFE_RELEASE(m_pReductionSurf[i]);
		SAFE_RELEASE(m_pReductionTex[i]);
	}
	SAFE_RELEASE(m_pFinalSurf);
	SAFE_RELEASE(m_pFinalTex);
	SAFE_RELEASE(m_pDiffuseSurf);
	SAFE_RELEASE(m_pDiffuseTex);
	SAFE_RELEASE(m_pNormalLockSurf);
	SAFE_RELEASE(m_pNormalLockTex);
	SAFE_RELEASE(m_pNormalSurf);
	SAFE_RELEASE(m_pNormalTex);
	SAFE_RELEASE(m_pPosLockSurf);
	SAFE_RELEASE(m_pPosLockTex);
	SAFE_RELEASE(m_pPosSurf);
	SAFE_RELEASE(m_pPosTex);
	SAFE_RELEASE(m_pMapZ);

	m_pMeshBg->InvalidateDeviceObjects();

    m_pFont->InvalidateDeviceObjects();	// tHg

	// VF[_
    if( m_pEffect != NULL ) m_pEffect->OnLostDevice();

    return S_OK;
}




//-------------------------------------------------------------
// Name: DeleteDeviceObjects()
// Desc: InitDeviceObjects() ō쐬IuWFNgJ
//-------------------------------------------------------------
HRESULT CMyD3DApplication::DeleteDeviceObjects()
{
    // VF[_
	SAFE_RELEASE( m_pEffect );
	
	// bV
	m_pMeshBg->Destroy();

    // tHg
    m_pFont->DeleteDeviceObjects();

    return S_OK;
}




//-------------------------------------------------------------
// Name: FinalCleanup()
// Desc: I钼ɌĂ΂
//-------------------------------------------------------------
HRESULT CMyD3DApplication::FinalCleanup()
{
    SAFE_DELETE( m_pMeshBg ); // bV

    SAFE_DELETE( m_pFont );	// tHg

    return S_OK;
}




